/* ---------------------------------------------------------- 
%   (C)1993,1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_G_METHTAB_H_
#define _KLIC_G_METHTAB_H_

#define GENERIC_SUCCEEDED  ((q) 0L)
#define GENERIC_FAILED     ((q) 1L)
#define GENERIC_GCREQUEST  ((q) 2L)

struct object {
  struct object_method_table* method_table;
};

struct object_method_table {
  long (*print) (struct object* g_self, FILE* g_fp,
		 unsigned long g_depth, unsigned long g_length );
  q* (*gc) (struct object* g_self);
  void (*deallocate) (struct object* g_self);
  q (*encode) (struct object* g_self, void* buffer, long depth);
};


/* Data Object */

struct data_object {
  struct data_object_method_table* method_table;
};

struct data_object_method_table {
  long (*print) (struct object* g_self, FILE* g_fp,
		 unsigned long g_depth, unsigned long g_length );
  q* (*gc) (struct object* g_self);
  void (*deallocate) (struct object* g_self);
  q (*encode) (struct object* g_self, void* buffer, long depth);

  q (*passive_unify)( /* struct data_object *one,
			 struct data_object *another */ );
  void (*active_unify)( /* struct data_object* one,
              with method_result      struct data_object* another */ );
  void (*body_generic)( /* struct data_object* obj,
				      q method_functor,
				      q* argv */ );
  q (*g_generic)( /* struct data_object *obj,
		     q method_functor,
		     q *args */ );
  q (*compare)( /* struct data_object *obj,
		   struct data_object *another_obj */ );
  q (*hash)( /* struct data_object *obj, unsigned long level */ );
};

#define data_objectp(obj) \
  ((struct data_object*) (((unsigned long) (obj)) - FUNCTOR))


/* Consumer Object */

struct consumer_object {
  struct consumer_object_method_table* method_table;
};

struct consumer_object_method_table {
  long (*print) (struct object* g_self, FILE* g_fp,
		 unsigned long g_depth, unsigned long g_length );
  q* (*gc) (struct object* g_self);
  void (*deallocate) (struct object* g_self);
  q (*encode) (struct object* g_self, void* buffer, long depth);

  void (*active_unify)(/* struct consumer_object* self,
		with method_result   q other */ );
};


/* Generator Object */
		    
struct generator_object {
  struct generator_object_method_table* method_table;
};

struct generator_object_method_table {
  long (*print) (struct object* g_self, FILE* g_fp,
		 unsigned long g_depth, unsigned long g_length );
  q* (*gc) (struct object* g_self);
  void (*deallocate) (struct object* g_self);
  q (*encode) (struct object* g_self, void* buffer, long depth);

  int (*active_unify)(/* q self, q other */);
  q (*generate)(/* struct generator_object* self */);
  q (*suspend)(/* q reference, struct goalrec* goal */);
};

#endif /* _KLIC_G_METHTAB_H_ */
