/* ---------------------------------------------------------- 
%   (C)1993,1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GG_MACRO_H_
#define _KLIC_GG_MACRO_H_

#include <klic/stdc.h>  /* CONCATENATE */
#include <klic/basic.h>  /* fatal, klic_fprintf */
#include <klic/g_basic.h>

extern q GC_wakeup_g_new();

/* runtime/generic.c */
extern q GG_MAKE_HOOK_VAR(struct generator_object* obj);

#define G_OBJ_SIZE  G_SIZE_IN_Q(G_OBJ_TYPE)

#define GG_TERMINATE  do{ return !0; }while(0)

#define GG_SUSPEND(var) \
do{ \
  q newvar, tmp; \
  q argv[2]; \
  G_MAKE_VAR(newvar); \
  argv[0] = g_term; \
  argv[1] = newvar; \
  tmp = GC_wakeup_g_new(2, argv); \
  GG_KL1_UNIFY((var), tmp); \
  return heapp(); \
}while(0)

/***************************************************************************/

#define GG_DEREF(x) \
do{ \
  while (1) { \
    if (!isstruct(x)) { \
      if (atomicnotref(x)) { \
	break; \
      } else { \
	q temp0 = derefone(x); \
	if(isref(temp0) && (x) == derefone(temp0)) { \
	  GG_SUSPEND(x); \
	} else { \
	  (x) = temp0; \
	} \
      } \
    } else { \
      break; \
    } \
  } \
}while(0)

/**********************************************************************/

#define GGDEF_UNIFY() \
static int G_rappend(active_unify) (q g_self, q g_term)

#define GGDEF_SUSPEND() \
static q G_rappend(suspend) (q g_self, struct goalrec* GG_GOAL)

#define GGDEF_GENERATE() \
static q G_rappend(generate) (G_OBJ_TYPE* g_self)

/*******************************************/

#define GGSET_INTARG_FOR_NEW(var,argv_i) \
do{ \
  G_DEREF_FOR_NEW(argv_i); \
  if( !isint(argv_i) ) fatal("not integer"); \
  (var) = intval(argv_i); \
}while(0)

extern struct predicate predicate_unify__term__dcode_xunify__goal_2;
#define GG_KL1_UNIFY(x, y) \
do{ \
  struct goalrec *gp; \
  G_HEAPALLOC(gp, 4, (struct goalrec *)); \
  gp->pred = &predicate_unify__term__dcode_xunify__goal_2; \
  gp->args[0] = (x); \
  gp->args[1] = (y); \
  resume_same_prio(gp); \
}while(0)

#endif /* _KLIC_GG_MACRO_H_ */
