/* ---------------------------------------------------------- 
%   (C)1993,1994 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */
#include <stdio.h>
#include <klic/gdobject.h>
#include "atom.h"
#include "funct.h"

struct GC_wakeup_object {
  struct consumer_object_method_table *method_table;
  q x;
  q y;
};

#define CLASS_NAME  GC_wakeup
#define G_OBJ_TYPE  struct GC_wakeup_object
#define G_OBJ_SIZE  sizeof(G_OBJ_TYPE)

#include <klic/gc_macro.h>

/* basic method definitions */

GCDEF_UNIFY()
{
  G_STD_DECL;

  GC_KL1_UNIFY(g_self->x, g_self->y);
  GC_TERMINATE;
}

G_DEF_GC()
{
  G_STD_DECL;
  G_OBJ_TYPE* newself;

  G_SET_NEWOBJ_IN_NEWGEN(newself);
  G_COPY_KL1_TERM_TO_NEWGEN(g_self->x, newself->x);
  G_COPY_KL1_TERM_TO_NEWGEN(g_self->y, newself->y);
  G_RETURN_FROM_GC(newself);
}


G_DEF_PRINT()
{
  G_STD_DECL;
  G_PRINT("$$WAKEUP$");
  G_RETURN_FROM_PRINT();
}

#define GCUSE_MY_UNIFY
#define GCUSE_MY_PRINT
#define GCUSE_MY_GC

/* define the method table structure of the merger */
#include <klic/gc_methtab.h>

/*  new_vector function */
G_DEF_NEW()
{
  G_STD_DECL_FOR_NEW();
  G_OBJ_TYPE* wakeup;
  q var;

  if (g_argc != 2) fatal("arity mismatch in creation of a merger.");

  G_SET_NEWOBJ_FOR_NEW(wakeup, G_OBJ_SIZE);
  wakeup->x = g_argv[0];
  wakeup->y = g_argv[1];
  var = GC_MAKE_HOOK_VAR((struct consumer_object*) wakeup);
  return var;
}
